/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */

/* This is a sample module using the generic javascript utilities code */
/* If it is working, it will block all images that contain 'mozilla' */

dump("******** starting nsGenericModule *********\n");

// used by Utils
Utils.debug = true;

// all other constants for local convenience only
const NAME = "Javascript Content Policy"
const CID = Components.ID("{b1f09db6-e7ac-47f6-a388-b8e124c674fa}");
const CONTRACT = "@mozilla.org/javascriptcontentpolicy;1";
const INTERFACE = Components.interfaces.nsIJavascriptContentPolicy;
const IS_SINGLETON = true;
const nsIContentPolicy = Components.interfaces.nsIContentPolicy;

var component = new Utils.genericComponent(NAME, CID, CONTRACT, IS_SINGLETON,
                                           INTERFACE, nsIContentPolicy);
var module = new Utils.genericModule("Generic", component);

component.register = function(compMgr, fileSpec, location, type) {
  this.printDebug("register() called");
  Utils.addCategoryEntry("content-policy", CONTRACT, NAME);
}

component.shouldLoad = function(type, location, context, window) {
  if (type != nsIContentPolicy.IMAGE) return true;
  var match = (/mozilla/.test(location.path));
  if (match) {
    this.printDebug("*** denying url '" + location.path + "'");
    return false;
  }
  return true
}

component.shouldProcess = function(type, location, context, window) {
  this.debug("(error) shouldProcess called");
  throw Components.results.NS_ERROR_NOT_IMPLEMENTED;
}

function NSGetModule(compMgr, fileSpec) { return module; }

